/**
 *	@file unitst_test_false.c
 *	@brief	unitst̂̎seXg.
 *	@note
 *		long double ֌W̕\~X悤ȂłƂ肠RgAEg
 */

#include "../unitst.h"

#ifdef _WIN32
 #include <tchar.h>
 #ifdef __BORLANDC__
  #ifdef UNICODE
   #define TCHAR	wchar_t
  #else
   #define TCHAR	char
  #endif
 #endif
 #define int64_t	__int64
 #define uint64_t	unsigned __int64
#else
 #include <stdint.h>
#endif


#if 1
// sp^[݂̂ňʂ}Ngp.
//UNITST_TEST( UniTst_false )
void UniTst_false(void)
{
	int 			i0 = 0;
	int 			i1 = 1;
	static unsigned ui = 100;
	int* pi0   = (int*)1;
	int* nullp = 0;
	int64_t  ll0 = 0;
	int64_t  ll1 = 10000;
	uint64_t ull = 10000;
	float		f0	= 0.f;
	float	 	f1	= 10.f;
	double	 	d0	= 0.0;
	double		d1	= 10.0;
	long double	 	ld0	= 0.0;
	long double		ld1	= 10.0;
	double 		ary[10] = {0};
	double* 	pa		= &ary[10];
	const char str0[] = "string";
  #ifndef ANSIC89
	const wchar_t wstr0[] = L"string";
  #endif

	UNITST_ADD_FAILUSE();

	//UNITST_ASSERT(i0 != i1-1);
	//UNITST_ASSERT_MSG(0, "assert_msg\n");
	//UNITST_ASSERT_MSGF(i0+1 != i1, ("assert_msgf %d,%d\n",1,2));

	//UNITST_ASSERT_PTR(nullp);
	//UNITST_ASSERT_PTR0(pi0);

	UNITST_CHECK(i0 != i1-1);
  #ifndef ANSIC89
	UNITST_CHECK_MSG(0, "check_msg\n");
  #endif
	UNITST_CHECK_MSGF(i0+1 != i1, ("check_msgf %d,%d\n",1,2));
	UNITST_CHECK_PTR(nullp);
	UNITST_CHECK_PTR0(pi0);

	UNITST_LIMIT(i0, 1, +10000);

	UNITST_LIM_BOOL(ui);
	UNITST_LIM_I(i0, 1, +10000);
	UNITST_LIM_I(i1, -10, 0);
	UNITST_LIM_I(ui,  1, 99);

	UNITST_LIM_LL(ll0, 1, +10000);
	UNITST_LIM_LL(ll1, -10, 0);
	UNITST_LIM_LL(ull, 10, +100);

	UNITST_LIM_F(f0, 0.1f, +10000.f);
	UNITST_LIM_F(f1, -10.f, 9.999f);

	UNITST_LIM_D(d0, 0.001, +10000.0);
	UNITST_LIM_D(d1, -10.1, +9.9999999999);

	UNITST_LIM_LD(ld0, 0.001, +10000.0);
	UNITST_LIM_LD(ld1, -10.1, +9.9999999999);

	UNITST_LIM_PTR(pa, ary, ary+9);

	UNITST_EQ(i0, f1);
	UNITST_EQ(i1, 0);
	UNITST_EQ(ll0, 1);
	UNITST_EQ(f0, 1);
	UNITST_EQ(d0, 1);
	UNITST_EQ(ld0, 1);

	UNITST_EQ_I(i1, 0);
	UNITST_EQ_LL(ll0, 1);
	UNITST_EQ_F(f0, 1);
	UNITST_EQ_D(d0, 1);
//	UNITST_EQ_LD(ld0, 1);
	UNITST_EQ_STR(str0, "STRING");
	UNITST_EQ_STRI(str0, "STRING1");
	UNITST_EQ_STRN(str0, "sTr", 3);
	UNITST_EQ_STRNI(str0, "St3", 3);
	UNITST_EQ_MEM(str0, "strIng", 7);

  #ifndef ANSIC89
	UNITST_EQ_WSTR(wstr0, L"STRING");
	UNITST_EQ_WSTRI(wstr0, L"STRING1");
	UNITST_EQ_WSTRN(wstr0, L"sTr", 3);
	UNITST_EQ_WSTRNI(wstr0, L"St3", 3);

   #ifdef _WIN32
	{
		const TCHAR tstr0[] = _T("string");
		UNITST_EQ_TSTR(tstr0, _T("STRING"));
		UNITST_EQ_TSTRI(tstr0, _T("STRING1"));
		UNITST_EQ_TSTRN(tstr0, _T("sTr"), 3);
		UNITST_EQ_TSTRNI(tstr0, _T("St3"), 3);
	}
   #endif
  #endif

	UNITST_EQ_DELTA_F(f0, 1, 0);
	UNITST_EQ_DELTA_D(d0, 1, 0);

	UNITST_NE(i0, f0);
	UNITST_NE_I(i1, 1);
	UNITST_NE_LL(ll0, 0);
	UNITST_NE_F(f0, 0);
	UNITST_NE_D(d0, 0);
//	UNITST_NE_LD(ld0, 0);
	UNITST_NE_MEM(str0, "string", 7);

	UNITST_LT(i0, 0);
	UNITST_LT_I(i0, 0);
	UNITST_LT_LL(ll0, 0);
	UNITST_LT_F(f0, 0);
	UNITST_LT_D(d0, 0);
//	UNITST_LT_LD(ld0, 0);

	UNITST_LE(i0, -1);
	UNITST_LE_I(i0, -1);
	UNITST_LE_LL(ll0, -1);
	UNITST_LE_F(f1, 0);
	UNITST_LE_D(d1, 0);
//	UNITST_LE_LD(ld1, 0);

	UNITST_GT(i0, 0);
	UNITST_GT_I(i0, 0);
	UNITST_GT_LL(ll0, 0);
	UNITST_GT_F(f0, 0);
	UNITST_GT_D(d0, 0);
//	UNITST_GT_LD(ld0, 0);

	UNITST_GE(i0, 10);
	UNITST_GE_I(i0, 10);
	UNITST_GE_LL(ll0, 10);
	UNITST_GE_F(f0, 10);
	UNITST_GE_D(d0, 10);
//	UNITST_GE_LD(ld0, 10);

	#if __STDC_VERSION__ >= 199901L || (_MSC_VER >= 1400) || (__GNUC__ >= 3) || (__BORLANDC__ >= 0x580) || (__WATCOMC__ >= 1260)	//|| (__SC__ >= 850)
	  #ifndef ANSIC89
		//UNITST_ASSERT_MSG(0, "assert_msg ex %d,%d,%d\n", 1,2,3);
		UNITST_CHECK_MSG(0, "check_msg ex %d,%d,%d\n", 1,2,3);
	  #endif
	#endif
}


UNITST_ADD_FUNC( UniTst_false )
#endif
