#ifdef USE_UNITST

#include "unitst.h"

UNItTeST_Test_T* UNItTeST_table(int n, int* curp) {
	static UNItTeST_Test_T	tests_[UNITST_MAX];
	static int				cur_ = 0;
	if (n < 0 && cur_ < UNITST_MAX) {
		n = cur_++;
	}
	if (n < 0 || n >= cur_) {
		return NULL;
	}
	if (curp)
		*curp = cur_;
	return &tests_[n];
}


/** eXg[`̓o^.
 */
void UNItTeST_add(void (*fnc)(), const char* name) {
	int size = 0;
	UNItTeST_Test_T* t = UNItTeST_table(-1, &size);
	if (t) {
		t->func_   = fnc;
		t->name_   = name;
	} else {
		UNITST_PRINTF(("too many UNITST.(%d)\n", UNITST_MAX));
		UNITST_ABORT();
	}
}


int UNItTeST_errCount(int cc, int mode, int* pErrs, int* pTotal) {
	static int errs  = 0;
	static int total = 0;
	if (mode) {
		if (pErrs)	*pErrs	= errs;
		else		errs	= 0;
		if (pTotal) *pTotal = total;
		else		total	= 0;
	} else {
		++total;
		if (cc == 0)
			++errs;
	}
	return cc;
}

#endif
