
#include "../unitst.h"

void compiler_version(void);


int main(void)
{
	compiler_version();
	UNITST_RUN_ALL();
	return 0;
}



void compiler_version(void)
{
  #if defined _MSC_VER
	UNITST_PRINTF(("_MSC_VER = %d\n", _MSC_VER));
  #elif defined __GNUC__
	UNITST_PRINTF(("__GNUC__ = %d\n", __GNUC__));
	UNITST_PRINTF(("__GNUC_MINOR__ = %d\n", __GNUC_MINOR__));
  #elif defined __DMC__
	UNITST_PRINTF(("__SC__ = %#x\n", __SC__));
	UNITST_PRINTF(("__DMC__ = %#x\n", __DMC__));
  #elif defined __BORLANDC__
	UNITST_PRINTF(("__BORLANDC__ = %#x\n", __BORLANDC__));
  #elif defined __WATCOMC__
	UNITST_PRINTF(("__WATCOMC__ = %d\n", __WATCOMC__));
  #endif
}



UNITST_DECL_BEGIN
	UNITST_DECL( UniTst_true )
	UNITST_DECL( UniTst_false )
UNITST_DECL_END
