/**
 *	@file	unitst.h
 *	@brief	c p ȈՂ P̃eXg .
 *	@date	2004-2010
 *	@author	tenk* (Masashi KITAMURA)
 *	@license Boost Software License Version 1.0
 *	@note
 *	- Ƃ D unittest ɐGčC++łCłɂ.
 *	- int=32,long long=64 O.
 *	- g.<br>
 *		RpC̃IvVŗ\ USE_UNITST`.
 *		unitst.c RpCΏۂɊ܂߂.
 *		eXg t@C 󋵂,
 *		<pre>
 *		UNITST_TEST(Foo_Test) {
 *			Foo* foo = Foo_create();
 *			UNITST_ASSERT_PTR(foo);
 *			....
 *		};
 *		</pre>
 *		̂悤ɂāAeeXgs[`Lq.
 *		ǂ̃t@C
 *		UNITST_DECL_BEGIN
 *			UNITST_DECL(Foo_Test)
 *			UNITST_DECL(Bar_Test)
 *		UNITST_DECL_END
 *		̂悤ȃeXg񋓂e[uPA.
 *		vON(main,WinMaint)̕Kvŏ̏̌ŁA<br>
 *		UNITST_RUN_ALL();						<br>
 *		ĂԂƊeeXgsB
 *	- o^łeXg[`͓̐K512ɐݒ.
 *		\ UNITST_MAX ɒlݒ肷΂̒lő吔ɂ.
 *	- G[Ɍo߃Oo͂Ȃꍇ́AUSE_UNITST̕ς
 *		USE_UNITST_NOLOG  `邱.
 */

#ifndef C_UNITST_H
#define C_UNITST_H


#if defined USE_UNITST_NOLOG && !(defined USE_UNITST)
#define USE_UNITST		USE_UNITST_NOLOG
#endif


#define UNITTEST(T)		UNITST_TEST(T)			// ݊.


#ifndef USE_UNITST	// ########################################################
// eXgȂƂ.
// ############################################################################

#define UNITST_RUN_ALL()		// mainWinMain̏[ɌĂяȏz.

#define UNITST_ADD_FUNC(F)

#ifdef __cplusplus
#define UNITST_TEST(T)		template<typename DMY> 	void uniTtesT_dmy_##T()
#else
#define UNITST_TEST(T)		static inline void uniTtesT_dmy_##T()
#endif

#define UNITST_RETURN()
#define UNITST_ADD_FAILUSE()
#define UNITST_FAIL()

#define UNITST_ASSERT(b)
#define UNITST_ASSERT_PTR(a)
#define UNITST_ASSERT_PTR0(a)
#define UNITST_ASSERT_MSGF(b, msg)
#define UNITST_ASSERT_MSG(b, m)

#define UNITST_CHECK(b)
#define UNITST_CHECK_PTR(a)
#define UNITST_CHECK_PTR0(a)
#define UNITST_CHECK_MSGF(b, msg)
#define UNITST_CHECK_MSG(b, m)

#define UNITST_LIMIT(a, mi, ma)
#define UNITST_EQ(a, b)
#define UNITST_NE(a, b)
#define UNITST_LT(a, b)
#define UNITST_LE(a, b)
#define UNITST_GT(a, b)
#define UNITST_GE(a, b)

#define UNITST_LIM_BOOL(a)
#define UNITST_LIM_I(a, mi, ma)
#define UNITST_LIM_LL(a,mi, ma)
#define UNITST_LIM_F(a, mi, ma)
#define UNITST_LIM_D(a, mi, ma)
#define UNITST_LIM_LD(a, mi, ma)
#define UNITST_LIM_PTR(a, mi, ma)

#define UNITST_EQ_DELTA_F(a,b,d)
#define UNITST_EQ_DELTA_D(a,b,d)

#define UNITST_EQ_I(a, b)
#define UNITST_EQ_LL(a, b)
#define UNITST_EQ_F(a, b)
#define UNITST_EQ_D(a, b)
#define UNITST_EQ_LD(a, b)

#define UNITST_NE_I(a, b)
#define UNITST_NE_LL(a, b)
#define UNITST_NE_F(a, b)
#define UNITST_NE_D(a, b)
#define UNITST_NE_LD(a, b)

#define UNITST_LT_I(a, b)
#define UNITST_LT_LL(a, b)
#define UNITST_LT_F(a, b)
#define UNITST_LT_D(a, b)
#define UNITST_LT_LD(a, b)

#define UNITST_LE_I(a, b)
#define UNITST_LE_LL(a, b)
#define UNITST_LE_F(a, b)
#define UNITST_LE_D(a, b)
#define UNITST_LE_LD(a, b)

#define UNITST_GT_I(a, b)
#define UNITST_GT_LL(a, b)
#define UNITST_GT_F(a, b)
#define UNITST_GT_D(a, b)
#define UNITST_GT_LD(a, b)

#define UNITST_GE_I(a, b)
#define UNITST_GE_LL(a, b)
#define UNITST_GE_F(a, b)
#define UNITST_GE_D(a, b)
#define UNITST_GE_LD(a, b)

#define UNITST_EQ_STR(a,b)
#define UNITST_EQ_STRN(a,b,n)
#define UNITST_EQ_STRI(a,b)
#define UNITST_EQ_STRNI(a,b,n)

#define UNITST_EQ_WSTR(a,b)
#define UNITST_EQ_WSTRN(a,b,n)
#define UNITST_EQ_WSTRI(a,b)
#define UNITST_EQ_WSTRNI(a,b,n)

#define UNITST_EQ_TSTR(a,b)
#define UNITST_EQ_TSTRI(a,b)
#define UNITST_EQ_TSTRN(a,b,n)
#define UNITST_EQ_TSTRNI(a,b,n)

#define UNITST_EQ_MEM(a, b, l)
#define UNITST_NE_MEM(a, b, l)


#else	// ####################################################################
// eXgƂ
// ############################################################################

#include <stddef.h>
#include <string.h>
#include <stdlib.h>

// ============================================================
// o^łeXg([`)̍ő吔̐ݒ.

#ifdef UNITST_MAX						// \UNITST_MAXݒς݂Ȃ炻A
#else									// ꍇ͂̒l(512)
  #define UNITST_MAX	512				///< UNITTEST̍ő吔.
#endif


// ============================================================
// ȈՂȃfobOpTu[`  RpC̒날킹.

#define UNITST_STR_CAT(a,b)		UNITST_STR_CAT_2(a,b)
#define UNITST_STR_CAT_2(a,b)	a##b

#if (defined _WIN32)
#define UNITST_INLINE	__inline
#else
#define UNITST_INLINE	inline
#endif

#ifdef DBG_H	// ----------------------------------------
 // dbg.h gĂꍇ͂ɏ
 #define UNITST_STATIC_ASSERT(cc)	DBG_STATIC_ASSERT(cc)
 #define UNITST_ABORT()				ERR_ABORT()
 #define UNITST_PRINTF(x)			ERR_PRINTF(x)
 #define UNITST_IS_RAM_PTR(p)		ERR_IS_RAM_PTR(p)

#else			// ----------------------------------------
 #include <stdio.h>
 #include <stdarg.h>

 #if defined _MSC_VER
  #define UNITST_STATIC_ASSERT(cc)	struct UNITST_STR_CAT(STATIC_ASSERT_CHECK_ST,__LINE__) { char dmy[2*((cc)!=0) - 1];};	\
									enum { UNITST_STR_CAT(STATIC_ASSERT_CHECK,__LINE__) = sizeof( UNITST_STR_CAT(STATIC_ASSERT_CHECK_ST,__LINE__) ) }
 #else
  #define UNITST_STATIC_ASSERT(cc)	typedef char UNITST_STR_CAT(STATIC_ASSERT_CHECK__LINE_,__LINE__)[(cc)? 1/*OK*/ : -1/*ERROR*/]
 #endif

 #if defined UNITST_ABORT	// `ς݂ȂAĒ`Ȃ.
 #elif defined _WINDOWS		// GUIAv̎
  #define UNITST_ABORT()		_CrtDbgBreak()
 #else						// R}hCEAv̂Ƃ.
  #define UNITST_ABORT()		exit(1) 		// ((*(char*)0) = 0)
 #endif

 #if defined UNITST_PRINTF	// `ς݂ȂĒ`Ȃ.
 #elif defined _WINDOWS		// GUIAv̎
  #define UNITST_PRINTF(x) 		unitst_printf x
  UNITST_INLINE void unitst_printf(const char* f, ...) {
	char b[0x4000];va_list a;va_start(a,f);vsnprintf(b,sizeof b,f,a); va_end(a); OutputDebugString(b);
  }
 #else						// R}hCEAv̂Ƃ.
  #define UNITST_PRINTF(x) 		unitst_printf x
  UNITST_INLINE void unitst_printf(const char* f, ...) {
	va_list a; va_start(a,f); vfprintf(stderr,f,a); va_end(a);
  }
 #endif

 #if defined UNITST_IS_RAM_PTR	// `ς݂ȂĒ`Ȃ.
 #elif (defined _WIN64) || (defined __WORDSIZE && __WORDSIZE == 64) || (defined _M_AMD64)
  #define UNITST_IS_RAM_PTR(p) 	((size_t)(ptrdiff_t)(p) >= 0x10000 && (size_t)(ptrdiff_t)(p) <= 0xFF00000000000000LL)
 #elif defined _WIN32
  #define UNITST_IS_RAM_PTR(p) 	((size_t)(ptrdiff_t)(p) >= 0x10000 && (size_t)(ptrdiff_t)(p) <= 0xFFFF0000)
 #else
  #define UNITST_IS_RAM_PTR(p) 	((p)!=0)
 #endif
#endif			// ----------------------------------------

#ifndef USE_UNITST_NOLOG
#define UNITST_LOG_PRINTF(x)		UNITST_PRINTF(x)
#else
#define UNITST_LOG_PRINTF(x)
#endif


// ============================================================
// eXgo^}N.

/// P̃eXg[`Lq邽߂̃}N. (D𑽏ӎ)
#define UNITST_TEST(T)		void UNItTeST_fnc_##T(void)

/// eXg[`̊֐w肵ēo^}N.
#define UNITST_ADD_FUNC(F)	void UNItTeST_fnc_##F(void) { F(); }

extern void UNItTeST_decl_begin(void);
#define UNITST_DECL_BEGIN		void UNItTeST_decl_begin(void) {
#define UNITST_DECL(T)			{ extern void UNItTeST_fnc_##T(void); UNItTeST_add(UNItTeST_fnc_##T, #T); }
#define UNITST_DECL_END			}


// ============================================================
/// jbgeXg̊ǗNX
typedef struct UNItTeST_Test_T {
	void			(*func_)();		///< eXg֐.
	const char*		name_;			///< eXg.
} UNItTeST_Test_T;


UNItTeST_Test_T* UNItTeST_table(int n, int* curp);
void 			 UNItTeST_add(void (*fnc)(), const char* name);
int 			 UNItTeST_errCount(int cc, int mode, int* pErrs, int* pTotal);


/** o^ĂeXg[`̎s.
 */
#define UNITST_RUN_ALL() 		do {										\
		unsigned failed = 0;												\
		int 	 size	= 0;												\
		int		 i;															\
		UNItTeST_decl_begin();												\
		UNItTeST_table(0, &size);											\
		UNITST_LOG_PRINTF(("### UNITST: %4d tests   (%s %s) ###\n"			\
			, size, __DATE__, __TIME__));									\
		for (i = 0; i < size; ++i) {										\
			int  errs	= 0;												\
			int  total	= 0;												\
			const char* name;												\
			UNItTeST_Test_T* t = UNItTeST_table(i, NULL);					\
			if (t == 0)														\
				break;														\
			name = t->name_;												\
			UNITST_LOG_PRINTF(("[test]    %s\n", name?name:""));			\
			UNItTeST_errCount(0, 1, 0,0);									\
			t->func_();														\
			UNItTeST_errCount(0, 1,&errs, &total);							\
			if (errs) {														\
				++failed;													\
				UNITST_PRINTF(("<FAILED>  %s (error:%d/%d)\n"				\
					, name, errs, total));									\
			} else {														\
				UNITST_LOG_PRINTF((" (ok)     %s\n", name));				\
			}																\
		}																	\
		if (failed) {														\
			UNITST_PRINTF(("=== %d tests, %d failed\n\n", size, failed));	\
			UNITST_ABORT();													\
		} else {															\
			UNITST_LOG_PRINTF(("=== %d tests  ok\n\n", size));				\
		}																	\
	} while (0)

#define UNITST_CHECK_COUNT(b)		(UNItTeST_errCount(b,0,0,0))	///< ĂtrueԂ.
#define UNITST_NOT(b)				(!UNItTeST_errCount(b,0,0,0))	///< ĂȂtrueԂ.




// ============================================================================
// ============================================================================
// UNITTEST(T) ɋLqA`FbNp̃}N.
// ============================================================================

#define UNITST_RETURN()				UNITST_ABORT()						///< eXg𒆒f
#define UNITST_ADD_FAILUSE()		UNITST_CHECK_COUNT(0)
#define UNITST_FAIL()				do {UNITST_PRINTF(("%s (%d): fail.\n",__FILE__,__LINE__));UNITST_RETURN();}while(0)

// UNITST_ASSERTn: `FbNAUȂ烁bZ[Wo͂āÃeXg𒆒f.
#define UNITST_ASSERT(b)			do {if (UNITST_NOT(b)) { UNITST_PRINTF(("%s (%d): [%s] failed.\n", __FILE__, __LINE__, #b)); UNITST_RETURN();} } while (0)
#define UNITST_ASSERT_PTR(a)		do {if (UNITST_NOT(UNITST_IS_RAM_PTR(a))) { UNITST_PRINTF(("%s (%d): %s(%p) is bad pointer.\n", __FILE__, __LINE__, #a, (a))); UNITST_RETURN();} } while (0)
#define UNITST_ASSERT_PTR0(a)		do {if (UNITST_NOT(UNITST_IS_RAM_PTR(a) || !(a))) { UNITST_PRINTF(("%s (%d): %s(%p) is bad pointer.\n", __FILE__,__LINE__,#a,(a))); UNITST_RETURN();} } while (0)
#define UNITST_ASSERT_MSGF(b, msg)	do {if (UNITST_NOT(b)) { UNITST_PRINTF(("%s (%d): [%s] failed. ", __FILE__, __LINE__, #b)); UNITST_PRINTF(msg); UNITST_RETURN();} } while (0)
#if __STDC_VERSION__ >= 199901L || (_MSC_VER >= 1400) || (__GNUC__ >= 3) || (__BORLANDC__ >= 0x580) || (__WATCOMC__ >= 1260)	//|| (__SC__ >= 850)
#define UNITST_ASSERT_MSG(b, ...)	do {if (UNITST_NOT(b)) { UNITST_PRINTF(("%s (%d): [%s] failed. ", __FILE__, __LINE__, #b)); UNITST_PRINTF((__VA_ARGS__)); UNITST_RETURN(); } } while (0)
#else
#define UNITST_ASSERT_MSG(b, m)		do {if (UNITST_NOT(b)) { UNITST_PRINTF(("%s (%d): [%s] failed. ", __FILE__, __LINE__, #b)); UNITST_PRINTF(("%s", m)); UNITST_RETURN(); } } while (0)
#endif

// UNITST_CHECKn: `FbNAUȂ烁bZ[Wo. eXĝ͌p.
#define UNITST_CHECK(b)				do {if (UNITST_NOT(b)) UNITST_PRINTF(("%s (%d): [%s] failed.\n", __FILE__, __LINE__, #b)); } while (0)
#define UNITST_CHECK_PTR(a)			do {if (UNITST_NOT(UNITST_IS_RAM_PTR(a))) UNITST_PRINTF(("%s (%d): %s(%p) is bad pointer.\n", __FILE__, __LINE__, #a, (a))); } while (0)
#define UNITST_CHECK_PTR0(a)		do {if (UNITST_NOT(UNITST_IS_RAM_PTR(a) || (a) == 0)) UNITST_PRINTF(("%s (%d): %s(%p) is bad pointer.\n", __FILE__, __LINE__, #a, (a))); } while (0)
#define UNITST_CHECK_MSGF(b, msg)	do {if (UNITST_NOT(b)) { UNITST_PRINTF(("%s (%d): [%s] failed. ", __FILE__, __LINE__, #b)); UNITST_PRINTF(msg); } } while (0)
#if __STDC_VERSION__ >= 199901L || (_MSC_VER >= 1400) || (__GNUC__ >= 3) || (__BORLANDC__ >= 0x580) || (__WATCOMC__ >= 1260)	//|| (__SC__ >= 850)
#define UNITST_CHECK_MSG(b, ...)	do {if (UNITST_NOT(b)) { UNITST_PRINTF(("%s (%d): [%s] failed. ", __FILE__, __LINE__, #b)); UNITST_PRINTF((__VA_ARGS__)); } } while (0)
#else
#define UNITST_CHECK_MSG(b, m)		do {if (UNITST_NOT(b)) { UNITST_PRINTF(("%s (%d): [%s] failed. ", __FILE__, __LINE__, #b)); UNITST_PRINTF(("%s", m)); } } while (0)
#endif

// ϐ͈̔̓`FbN. ͈͊OȂ烁bZ[W\. (͌p)
// a,b ̊֌W`FbN. ĂȂꍇbZ[W\. (͌p)

#define UNITST_LIMIT(a, mi, ma)		do {if (UNITST_NOT((mi) <= (a) && (a) <= (ma))) UNITST_PRINTF(("%s (%d): %s, Out of range[%s .. %s]\n", __FILE__, __LINE__, #a,#mi,#ma));} while(0)
#define UNITST_EQ(a, b)				do {if (UNITST_NOT((a) == (b))) UNITST_PRINTF(("%s (%d): [%s == %s] failed.\n", __FILE__, __LINE__, #a, #b )); } while (0)
#define UNITST_NE(a, b)				do {if (UNITST_NOT((a) != (b))) UNITST_PRINTF(("%s (%d): [%s != %s] failed.\n", __FILE__, __LINE__, #a, #b )); } while (0)
#define UNITST_LT(a, b)				do {if (UNITST_NOT((a) <  (b))) UNITST_PRINTF(("%s (%d): [%s <  %s] failed.\n", __FILE__, __LINE__, #a, #b )); } while (0)
#define UNITST_LE(a, b)				do {if (UNITST_NOT((a) <= (b))) UNITST_PRINTF(("%s (%d): [%s <= %s] failed.\n", __FILE__, __LINE__, #a, #b )); } while (0)
#define UNITST_GT(a, b)				do {if (UNITST_NOT((a) >  (b))) UNITST_PRINTF(("%s (%d): [%s >  %s] failed.\n", __FILE__, __LINE__, #a, #b )); } while (0)
#define UNITST_GE(a, b)				do {if (UNITST_NOT((a) >= (b))) UNITST_PRINTF(("%s (%d): [%s >= %s] failed.\n", __FILE__, __LINE__, #a, #b )); } while (0)

#define UNITST_LIM_BOOL(a) 			do {if (UNITST_NOT((int)(a) == 0 || (int)(a) == 1)) UNITST_PRINTF(("%s (%d): %s=%d(%#x), Out of range[%d..%d]\n", __FILE__, __LINE__, #a,(a),(a),	0 ,   1  ));} while(0)
#define UNITST_LIM_I(a, mi, ma)		do {if (UNITST_NOT((mi) <= (a) && (a) <= (ma))) UNITST_PRINTF(("%s (%d): %s=%d(%#x), Out of range[%d..%d]\n", __FILE__, __LINE__, #a,(a),(a), (mi), (ma) ));} while(0)
#define UNITST_LIM_F(a, mi, ma)		do {const float  *aa=&(a);aa; if (UNITST_NOT((mi) <= (a) && (a) <= (ma))) UNITST_PRINTF(("%s (%d): %s=%g, Out of range[%g..%g]\n", __FILE__, __LINE__, #a,(double)(a), (double)(mi), (double)(ma) ));} while(0)
#define UNITST_LIM_D(a, mi, ma)		do {const double *aa=&(a);aa; if (UNITST_NOT((mi) <= (a) && (a) <= (ma))) UNITST_PRINTF(("%s (%d): %s=%g, Out of range[%g..%g]\n", __FILE__, __LINE__, #a,(double)(a), (double)(mi), (double)(ma) ));} while(0)
#define UNITST_LIM_LD(a, mi, ma)	do {const long double *aa=&(a);aa; if (UNITST_NOT((mi) <= (a) && (a) <= (ma))) UNITST_PRINTF(("%s (%d): %s=%Lg, Out of range[%g..%g]\n", __FILE__, __LINE__, #a,(long double)(a), (long double)(mi), (long double)(ma) ));} while(0)
#define UNITST_LIM_PTR(a, mi, ma)	do {if (UNITST_NOT((char*)(mi) <=(char*)(a) && (char*)(a) <=(char*)(ma))) UNITST_PRINTF(("%s (%d): %s=%#p, Out of range[%p..%p]\n",__FILE__, __LINE__, #a, (a), (mi), (ma) ));} while(0)

#define UNITST_EQ_I(a, b)			do {if (UNITST_NOT((a) == (b))) UNITST_PRINTF(("%s (%d): [%s(%d) == %s(%d)] failed.\n", __FILE__, __LINE__, #a, (a), #b, (b) )); } while (0)
#define UNITST_EQ_F(a, b)			do {if (UNITST_NOT((a) == (b))) UNITST_PRINTF(("%s (%d): [%s(%g) == %s(%g)] failed.\n", __FILE__, __LINE__, #a, (double)(a), #b, (double)(b) )); } while (0)
#define UNITST_EQ_D(a, b)			do {if (UNITST_NOT((a) == (b))) UNITST_PRINTF(("%s (%d): [%s(%g) == %s(%g)] failed.\n", __FILE__, __LINE__, #a, (double)(a), #b, (double)(b) )); } while (0)
#define UNITST_EQ_LD(a, b)			do {if (UNITST_NOT((a) == (b))) UNITST_PRINTF(("%s (%d): [%s(%Lg) == %s(%Lg)] failed.\n", __FILE__, __LINE__, #a, (long double)(a), #b, (long double)(b) )); } while (0)

#define UNITST_EQ_STR(a,b)			do {const char*    A_=(a),*B_=(b); if (UNITST_NOT(A_==B_||(A_&&B_&& !strcmp 	(A_,B_	  )))) UNITST_PRINTF(("%s (%d): [%s(%s) == %s(%s)] failed.\n"		  ,__FILE__,__LINE__,#a,A_,#b,B_	)); } while (0)
#define UNITST_EQ_STRN(a,b,n)		do {const char*    A_=(a),*B_=(b); if (UNITST_NOT(A_==B_||(A_&&B_&& !strncmp	(A_,B_,(n))))) UNITST_PRINTF(("%s (%d): [%s(%s) == %s(%s) len=%d] failed.\n"  ,__FILE__,__LINE__,#a,A_,#b,B_,(n))); } while (0)
#define UNITST_EQ_WSTR(a,b) 	 	do {const wchar_t* A_=(a),*B_=(b); if (UNITST_NOT(A_==B_||(A_&&B_&& !wcscmp 	(A_,B_	  )))) UNITST_PRINTF(("%s (%d): [%s(%ls) == %s(%ls)] failed.\n" 	  ,__FILE__,__LINE__,#a,A_,#b,B_	)); } while (0)
#define UNITST_EQ_WSTRN(a,b,n)		do {const wchar_t* A_=(a),*B_=(b); if (UNITST_NOT(A_==B_||(A_&&B_&& !wcsncmp	(A_,B_,(n))))) UNITST_PRINTF(("%s (%d): [%s(%ls) == %s(%ls) len=%d] failed.\n",__FILE__,__LINE__,#a,A_,#b,B_,(n))); } while (0)
#if defined _WIN32
#define UNITST_EQ_STRI(a,b)  		do {const char*    A_=(a),*B_=(b); if (UNITST_NOT(A_==B_||(A_&&B_&& !stricmp	(A_,B_	  )))) UNITST_PRINTF(("%s (%d): [%s(%s) == %s(%s)] failed.\n"		  ,__FILE__,__LINE__,#a,A_,#b,B_	)); } while (0)
#define UNITST_EQ_STRNI(a,b,n)		do {const char*    A_=(a),*B_=(b); if (UNITST_NOT(A_==B_||(A_&&B_&& !strnicmp	(A_,B_,(n))))) UNITST_PRINTF(("%s (%d): [%s(%s) == %s(%s) len=%d] failed.\n"  ,__FILE__,__LINE__,#a,A_,#b,B_,(n))); } while (0)
#define UNITST_EQ_WSTRI(a,b)  		do {const wchar_t* A_=(a),*B_=(b); if (UNITST_NOT(A_==B_||(A_&&B_&& !_wcsicmp	(A_,B_	  )))) UNITST_PRINTF(("%s (%d): [%s(%ls) == %s(%ls)] failed.\n"		  ,__FILE__,__LINE__,#a,A_,#b,B_	)); } while (0)
#define UNITST_EQ_WSTRNI(a,b,n)		do {const wchar_t* A_=(a),*B_=(b); if (UNITST_NOT(A_==B_||(A_&&B_&& !_wcsnicmp	(A_,B_,(n))))) UNITST_PRINTF(("%s (%d): [%s(%ls) == %s(%ls) len=%d] failed.\n",__FILE__,__LINE__,#a,A_,#b,B_,(n))); } while (0)
#else
#define UNITST_EQ_STRI(a,b)  		do {const char*    A_=(a),*B_=(b); if (UNITST_NOT(A_==B_||(A_&&B_&& !strcasecmp (A_,B_	  )))) UNITST_PRINTF(("%s (%d): [%s(%s) == %s(%s)] failed.\n"		  ,__FILE__,__LINE__,#a,A_,#b,B_	)); } while (0)
#define UNITST_EQ_STRNI(a,b,n)		do {const char*    A_=(a),*B_=(b); if (UNITST_NOT(A_==B_||(A_&&B_&& !strncasecmp(A_,B_,(n))))) UNITST_PRINTF(("%s (%d): [%s(%s) == %s(%s) len=%d] failed.\n"  ,__FILE__,__LINE__,#a,A_,#b,B_,(n))); } while (0)
#define UNITST_EQ_WSTRI(a,b)  		do {const wchar_t* A_=(a),*B_=(b); if (UNITST_NOT(A_==B_||(A_&&B_&& !wcscasecmp (A_,B_	  )))) UNITST_PRINTF(("%s (%d): [%s(%ls) == %s(%ls)] failed.\n"		  ,__FILE__,__LINE__,#a,A_,#b,B_	)); } while (0)
#define UNITST_EQ_WSTRNI(a,b,n)		do {const wchar_t* A_=(a),*B_=(b); if (UNITST_NOT(A_==B_||(A_&&B_&& !wcsncasecmp(A_,B_,(n))))) UNITST_PRINTF(("%s (%d): [%s(%ls) == %s(%ls) len=%d] failed.\n",__FILE__,__LINE__,#a,A_,#b,B_,(n))); } while (0)
#endif

#define UNITST_EQ_MEM(a, b, l)		do {const void* A_=(a),*B_=(b); if (UNITST_NOT(A_==B_|| (A_&&B_&& memcmp(  A_,B_,(l)) == 0))) UNITST_PRINTF(("%s (%d): [%s == %s (%dbytes)] failed.\n", __FILE__, __LINE__, #a, #b, (l))); } while (0)

#define UNITST_EQ_DELTA_F(a,b,d)	do {const float  *aa=&(a);aa; if (UNITST_NOT((a) >= (b)-(d) && (a) <= (b)+(d))) UNITST_PRINTF(("%s (%d): [%s(%g) == %s(%g)] failed.\n", __FILE__, __LINE__, #a, (double)(a), #b, (double)(b) )); } while (0)
#define UNITST_EQ_DELTA_D(a,b,d)	do {const double *aa=&(a);aa; if (UNITST_NOT((a) >= (b)-(d) && (a) <= (b)+(d))) UNITST_PRINTF(("%s (%d): [%s(%g) == %s(%g)] failed.\n", __FILE__, __LINE__, #a, (double)(a), #b, (double)(b) )); } while (0)

#define UNITST_NE_I(a, b)			do {if (UNITST_NOT((a) != (b))) UNITST_PRINTF(("%s (%d): [%s(%d) != %s(%d)] failed.\n"			, __FILE__, __LINE__, #a,		  (a), #b,		   (b) )); } while (0)
#define UNITST_NE_F(a, b)			do {if (UNITST_NOT((a) != (b))) UNITST_PRINTF(("%s (%d): [%s(%g) != %s(%g)] failed.\n"			, __FILE__, __LINE__, #a, (double)(a), #b, (double)(b) )); } while (0)
#define UNITST_NE_D(a, b)			do {if (UNITST_NOT((a) != (b))) UNITST_PRINTF(("%s (%d): [%s(%g) != %s(%g)] failed.\n"			, __FILE__, __LINE__, #a, (double)(a), #b, (double)(b) )); } while (0)
#define UNITST_NE_LD(a, b)			do {if (UNITST_NOT((a) != (b))) UNITST_PRINTF(("%s (%d): [%s(%Lg) != %s(%Lg)] failed.\n"		, __FILE__, __LINE__, #a, (long double)(a), #b, (long double)(b) )); } while (0)

#define UNITST_NE_MEM(a, b, l)		do {const void* A_=(a),*B_=(b); if (UNITST_NOT(A_!=B_&& (!A_||!B_|| memcmp(  A_,B_,(l))))) UNITST_PRINTF(("%s (%d): [%s != %s (%dbytes)] failed.\n", __FILE__, __LINE__, #a, #b, (l))); } while (0)

#define UNITST_LT_I(a, b)			do {if (UNITST_NOT((a) <  (b))) UNITST_PRINTF(("%s (%d): [%s(%d : %x) < %s(%d : %x)] failed.\n" , __FILE__, __LINE__, #a, (a), (a)	 , #b, (b), (b)    )); } while (0)
#define UNITST_LT_F(a, b)			do {if (UNITST_NOT((a) <  (b))) UNITST_PRINTF(("%s (%d): [%s(%g) < %s(%g)] failed.\n"			, __FILE__, __LINE__, #a, (double)(a), #b, (double)(b) )); } while (0)
#define UNITST_LT_D(a, b)			do {if (UNITST_NOT((a) <  (b))) UNITST_PRINTF(("%s (%d): [%s(%g) < %s(%g)] failed.\n"			, __FILE__, __LINE__, #a, (double)(a), #b, (double)(b) )); } while (0)
#define UNITST_LT_LD(a, b)			do {if (UNITST_NOT((a) <  (b))) UNITST_PRINTF(("%s (%d): [%s(%Lg) < %s(%Lg)] failed.\n"			, __FILE__, __LINE__, #a, (long double)(a), #b, (long double)(b) )); } while (0)

#define UNITST_LE_I(a, b)			do {if (UNITST_NOT((a) <= (b))) UNITST_PRINTF(("%s (%d): [%s(%d : %x) <= %s(%d : %x)] failed.\n", __FILE__, __LINE__, #a, (a), (a)	 , #b, (b), (b)    )); } while (0)
#define UNITST_LE_F(a, b)			do {if (UNITST_NOT((a) <= (b))) UNITST_PRINTF(("%s (%d): [%s(%g) <= %s(%g)] failed.\n"			, __FILE__, __LINE__, #a, (double)(a), #b, (double)(b) )); } while (0)
#define UNITST_LE_D(a, b)			do {if (UNITST_NOT((a) <= (b))) UNITST_PRINTF(("%s (%d): [%s(%g) <= %s(%g)] failed.\n"			, __FILE__, __LINE__, #a, (double)(a), #b, (double)(b) )); } while (0)
#define UNITST_LE_LD(a, b)			do {if (UNITST_NOT((a) <= (b))) UNITST_PRINTF(("%s (%d): [%s(%Lg) <= %s(%Lg)] failed.\n"		, __FILE__, __LINE__, #a, (long double)(a), #b, (long double)(b) )); } while (0)

#define UNITST_GT_I(a, b)			do {if (UNITST_NOT((a) >  (b))) UNITST_PRINTF(("%s (%d): [%s(%d : %x) > %s(%d : %x)] failed.\n" , __FILE__, __LINE__, #a, (a), (a)	 , #b, (b), (b)    )); } while (0)
#define UNITST_GT_F(a, b)			do {if (UNITST_NOT((a) >  (b))) UNITST_PRINTF(("%s (%d): [%s(%g) > %s(%g)] failed.\n"			, __FILE__, __LINE__, #a, (double)(a), #b, (double)(b) )); } while (0)
#define UNITST_GT_D(a, b)			do {if (UNITST_NOT((a) >  (b))) UNITST_PRINTF(("%s (%d): [%s(%g) > %s(%g)] failed.\n"			, __FILE__, __LINE__, #a, (double)(a), #b, (double)(b) )); } while (0)
#define UNITST_GT_LD(a, b)			do {if (UNITST_NOT((a) >  (b))) UNITST_PRINTF(("%s (%d): [%s(%Lg) > %s(%Lg)] failed.\n"			, __FILE__, __LINE__, #a, (long double)(a), #b, (long double)(b) )); } while (0)

#define UNITST_GE_I(a, b)			do {if (UNITST_NOT((a) >= (b))) UNITST_PRINTF(("%s (%d): [%s(%d : %x) >= %s(%d : %x)] failed.\n", __FILE__, __LINE__, #a, (a), (a)	 , #b, (b), (b)    )); } while (0)
#define UNITST_GE_F(a, b)			do {if (UNITST_NOT((a) >= (b))) UNITST_PRINTF(("%s (%d): [%s(%g) >= %s(%g)] failed.\n"			, __FILE__, __LINE__, #a, (double)(a), #b, (double)(b) )); } while (0)
#define UNITST_GE_D(a, b)			do {if (UNITST_NOT((a) >= (b))) UNITST_PRINTF(("%s (%d): [%s(%g) >= %s(%g)] failed.\n"			, __FILE__, __LINE__, #a, (double)(a), #b, (double)(b) )); } while (0)
#define UNITST_GE_LD(a, b)			do {if (UNITST_NOT((a) >= (b))) UNITST_PRINTF(("%s (%d): [%s(%Lg) >= %s(%Lg)] failed.\n"		, __FILE__, __LINE__, #a, (long double)(a), #b, (long double)(b) )); } while (0)


// printf  ll T|[g̏ꍇp. mscȊÕo[W`FbN͓K.
#if (defined _MSC_VER && _MSC_VER < 1400) || (defined __GNUC__ && __GNUC__ < 3) || (defined __SC__ && __SC__ < 840) || (defined __BORLANDC__ && __BORLANDC__ < 0x0560) || (defined __WATCOMC__ && __WATCOMC__ < 1200)
#ifdef _WIN32
#define UNITST_LL_HI(a)				( (unsigned)((unsigned __int64)(a)>>32) )
#else
#define UNITST_LL_HI(a)				( (unsigned)((uint64_t)(a)>>32) )
#endif
#define UNITST_LIM_LL(a,mi,ma)		do {if (UNITST_NOT((mi) <= (a) && (a) <= (ma))) UNITST_PRINTF(("%s (%d): %s=0x%x%08x, Out of range[0x%x%08x..0x%x%08x]\n" 				\
										, __FILE__, __LINE__, #a, UNITST_LL_HI(a), (unsigned)(a),UNITST_LL_HI(mi), (unsigned)(mi),UNITST_LL_HI(ma), (unsigned)(ma) ));} while(0)
#define UNITST_EQ_LL(a, b)			do {if (UNITST_NOT((a) == (b))) UNITST_PRINTF(("%s (%d): [%s(0x%x%08x) == %s(0x%x%08x)] failed.\n", __FILE__, __LINE__, #a, UNITST_LL_HI(a), (unsigned)(a), #b, (UNITST_LL_HI(b), (unsigned)(b) )); } while (0)
#define UNITST_NE_LL(a, b)			do {if (UNITST_NOT((a) != (b))) UNITST_PRINTF(("%s (%d): [%s(0x%x%08x) != %s(0x%x%08x)] failed.\n", __FILE__, __LINE__, #a, UNITST_LL_HI(a), (unsigned)(a), #b, (UNITST_LL_HI(b), (unsigned)(b) )); } while (0)
#define UNITST_LT_LL(a, b)			do {if (UNITST_NOT((a) <  (b))) UNITST_PRINTF(("%s (%d): [%s(0x%x%08x) <  %s(0x%x%08x)] failed.\n", __FILE__, __LINE__, #a, UNITST_LL_HI(a), (unsigned)(a), #b, (UNITST_LL_HI(b), (unsigned)(b) )); } while (0)
#define UNITST_LE_LL(a, b)			do {if (UNITST_NOT((a) <= (b))) UNITST_PRINTF(("%s (%d): [%s(0x%x%08x) <= %s(0x%x%08x)] failed.\n", __FILE__, __LINE__, #a, UNITST_LL_HI(a), (unsigned)(a), #b, (UNITST_LL_HI(b), (unsigned)(b) )); } while (0)
#define UNITST_GT_LL(a, b)			do {if (UNITST_NOT((a) >  (b))) UNITST_PRINTF(("%s (%d): [%s(0x%x%08x) >  %s(0x%x%08x)] failed.\n", __FILE__, __LINE__, #a, UNITST_LL_HI(a), (unsigned)(a), #b, (UNITST_LL_HI(b), (unsigned)(b) )); } while (0)
#define UNITST_GE_LL(a, b)			do {if (UNITST_NOT((a) >= (b))) UNITST_PRINTF(("%s (%d): [%s(0x%x%08x) >= %s(0x%x%08x)] failed.\n", __FILE__, __LINE__, #a, UNITST_LL_HI(a), (unsigned)(a), #b, (UNITST_LL_HI(b), (unsigned)(b) )); } while (0)
#else	// long long T|[gĂƂ.
#define UNITST_LIM_LL(a,mi, ma)		do {if (UNITST_NOT((mi) <= (a) && (a) <= (ma))) UNITST_PRINTF(("%s (%d): %s=%lld(%#llx), Out of range[%lld..%lld]\n"					\
										, __FILE__, __LINE__, #a,(unsigned long long)(a), (unsigned long long)(a), (unsigned long long)(mi), (unsigned long long)(ma) ));} while(0)
#define UNITST_EQ_LL(a, b)			do {if (UNITST_NOT((a) == (b))) UNITST_PRINTF(("%s (%d): [%s(%#llx) == %s(%#llx)] failed.\n", __FILE__, __LINE__, #a, (unsigned long long)(a), #b, (unsigned long long)(b) )); } while (0)
#define UNITST_NE_LL(a, b)			do {if (UNITST_NOT((a) != (b))) UNITST_PRINTF(("%s (%d): [%s(%#llx) != %s(%#llx)] failed.\n", __FILE__, __LINE__, #a, (unsigned long long)(a), #b, (unsigned long long)(b) )); } while (0)
#define UNITST_LT_LL(a, b)			do {if (UNITST_NOT((a) <  (b))) UNITST_PRINTF(("%s (%d): [%s(%#llx) <  %s(%#llx)] failed.\n", __FILE__, __LINE__, #a, (unsigned long long)(a), #b, (unsigned long long)(b) )); } while (0)
#define UNITST_LE_LL(a, b)			do {if (UNITST_NOT((a) <= (b))) UNITST_PRINTF(("%s (%d): [%s(%#llx) <= %s(%#llx)] failed.\n", __FILE__, __LINE__, #a, (unsigned long long)(a), #b, (unsigned long long)(b) )); } while (0)
#define UNITST_GT_LL(a, b)			do {if (UNITST_NOT((a) >  (b))) UNITST_PRINTF(("%s (%d): [%s(%#llx) >  %s(%#llx)] failed.\n", __FILE__, __LINE__, #a, (unsigned long long)(a), #b, (unsigned long long)(b) )); } while (0)
#define UNITST_GE_LL(a, b)			do {if (UNITST_NOT((a) >= (b))) UNITST_PRINTF(("%s (%d): [%s(%#llx) >= %s(%#llx)] failed.\n", __FILE__, __LINE__, #a, (unsigned long long)(a), #b, (unsigned long long)(b) )); } while (0)
#endif

// TCHAR Ή.
#ifdef UNICODE
#define UNITST_EQ_TSTR(a,b)			UNITST_EQ_WSTR(a,b)
#define UNITST_EQ_TSTRI(a,b)		UNITST_EQ_WSTRI(a,b)
#define UNITST_EQ_TSTRN(a,b,n)		UNITST_EQ_WSTRN(a,b,n)
#define UNITST_EQ_TSTRNI(a,b,n)		UNITST_EQ_WSTRNI(a,b,n)
#else
#define UNITST_EQ_TSTR(a,b)			UNITST_EQ_STR(a,b)
#define UNITST_EQ_TSTRI(a,b)		UNITST_EQ_STRI(a,b)
#define UNITST_EQ_TSTRN(a,b,n)		UNITST_EQ_STRN(a,b,n)
#define UNITST_EQ_TSTRNI(a,b,n)		UNITST_EQ_STRNI(a,b,n)
#endif


#endif	// ####################################################################
// ############################################################################


#endif	// UNITST_H
